Index: src/data/variable.h
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/variable.h,v
retrieving revision 1.15
diff -u -p -r1.15 variable.h
--- src/data/variable.h	7 Dec 2006 06:31:04 -0000	1.15
+++ src/data/variable.h	10 Dec 2006 03:30:21 -0000
@@ -20,101 +20,43 @@
 #if !variable_h
 #define variable_h 1
 
-
 #include <stddef.h>
 #include "config.h"
 #include <stdbool.h>
-#include "category.h"
-#include "format.h"
-#include "missing-values.h"
+
+union value;
 
 /* Variable type. */
 enum var_type
   {
-    NUMERIC,			/* A numeric variable. */
-    ALPHA			/* A string variable. */
+    VAR_NUMERIC,                /* A numeric variable. */
+    VAR_STRING			/* A string variable. */
   };
 
 bool var_type_is_valid (enum var_type);
-const char *var_type_adj (enum var_type);
-const char *var_type_noun (enum var_type);
-
-/* Alignment of data for display. */
-enum alignment 
-  {
-    ALIGN_LEFT = 0,
-    ALIGN_RIGHT = 1,
-    ALIGN_CENTRE = 2,
-    n_ALIGN
-  };
+enum var_type var_type_from_width (int width);
 
-bool alignment_is_valid (enum alignment);
+/* Variables. */
+struct variable *var_create (const char *name, int width);
+struct variable *var_clone (const struct variable *);
+void var_destroy (struct variable *);
+
+/* Variable names.
+   Long variable names can be used in most contexts, but a few
+   procedures and file formats are limited to short names. */
+#define SHORT_NAME_LEN 8
+#define LONG_NAME_LEN 64
 
-/* How data is measured. */
-enum measure
-  {
-    MEASURE_NOMINAL = 1,
-    MEASURE_ORDINAL = 2,
-    MEASURE_SCALE = 3,
-    n_MEASURES
-  };
-
-bool measure_is_valid (enum measure);
-
-/* Maximum lengths of short and long variable names.
-   Most operations support long variable names,
-   but some file formats are limited to short names. */
-#define SHORT_NAME_LEN 8        /* Short name length. */
-#define LONG_NAME_LEN 64        /* Long name length. */
-
-/* A variable's dictionary entry.  */
-struct variable
-  {
-    /* Dictionary information. */
-    char name[LONG_NAME_LEN + 1]; /* Variable name.  Mixed case. */
-    int width;			/* 0 for numeric, otherwise string width. */
-    struct missing_values miss; /* Missing values. */
-    struct fmt_spec print;	/* Default format for PRINT. */
-    struct fmt_spec write;	/* Default format for WRITE. */
-    struct val_labs *val_labs;  /* Value labels. */
-    char *label;		/* Variable label. */
-
-    /* GUI information. */
-    enum measure measure;       /* Nominal, ordinal, or continuous. */
-    int display_width;          /* Width of data editor column. */
-    enum alignment alignment;   /* Alignment of data in GUI. */
-
-    /* Case information. */
-    int fv;			/* Index into `value's. */
-    bool leave;                 /* Leave value from case to case? */
-
-    /* Data for use by containing dictionary. */
-    int index;			/* Dictionary index. */
-
-    /* Short name, used only for system and portable file input
-       and output.  Upper case only.  There is no index for short
-       names.  Short names are not necessarily unique.  Any
-       variable may have no short name, indicated by an empty
-       string. */
-    char short_name[SHORT_NAME_LEN + 1];
-
-    /* Each command may use these fields as needed. */
-    void *aux;
-    void (*aux_dtor) (struct variable *);
-
-    /* Values of a categorical variable.  Procedures need
-       vectors with binary entries, so any variable of type ALPHA will
-       have its values stored here. */
-    struct cat_vals *obs_vals;
-  };
-
-/* Variable names. */
 const char *var_get_name (const struct variable *);
 void var_set_name (struct variable *, const char *);
 bool var_is_valid_name (const char *, bool issue_error);
 bool var_is_plausible_name (const char *name, bool issue_error);
-int  compare_var_names (const void *, const void *, const void *);
-unsigned hash_var_name (const void *, const void *);
+
+int compare_vars_by_name (const void *, const void *, const void *);
+unsigned hash_var_by_name (const void *, const void *);
+
+int compare_var_ptrs_by_name (const void *, const void *, const void *);
+unsigned hash_var_ptr_by_name (const void *, const void *);
 
 /* Variable types and widths. */
 enum var_type var_get_type (const struct variable *);
@@ -124,7 +66,7 @@ bool var_is_numeric (const struct variab
 bool var_is_alpha (const struct variable *);
 bool var_is_short_string (const struct variable *);
 bool var_is_long_string (const struct variable *);
-bool var_is_very_long_string (const struct variable *);
+size_t var_get_value_cnt (const struct variable *);
 
 /* Variables' missing values. */
 const struct missing_values *var_get_missing_values (const struct variable *);
@@ -144,6 +86,19 @@ bool var_is_str_user_missing (const stru
 bool var_is_value_system_missing (const struct variable *,
                                   const union value *);
 
+/* Value labels. */
+const struct val_labs *var_get_value_labels (const struct variable *);
+bool var_has_value_labels (const struct variable *);
+void var_set_value_labels (struct variable *, const struct val_labs *);
+bool var_add_value_label (struct variable *,
+                          const union value *, const char *);
+void var_replace_value_label (struct variable *,
+                              const union value *, const char *);
+void var_clear_value_labels (struct variable *);
+const char *var_lookup_value_label (const struct variable *,
+                                    const union value *);
+const char *var_get_value_name (const struct variable *, const union value *);
+
 /* Print and write formats. */
 const struct fmt_spec *var_get_print_format (const struct variable *);
 void var_set_print_format (struct variable *, const struct fmt_spec *);
@@ -152,45 +107,70 @@ void var_set_write_format (struct variab
 void var_set_both_formats (struct variable *, const struct fmt_spec *);
 
 /* Variable labels. */
+const char *var_to_string (const struct variable *);
 const char *var_get_label (const struct variable *);
 void var_set_label (struct variable *, const char *);
 void var_clear_label (struct variable *);
 bool var_has_label (const struct variable *);
 
-/* GUI information. */
+/* How data is measured. */
+enum measure
+  {
+    MEASURE_NOMINAL = 1,
+    MEASURE_ORDINAL = 2,
+    MEASURE_SCALE = 3,
+    n_MEASURES
+  };
+
+bool measure_is_valid (enum measure);
 enum measure var_get_measure (const struct variable *);
 void var_set_measure (struct variable *, enum measure);
 
+/* GUI display width. */
 int var_get_display_width (const struct variable *);
 void var_set_display_width (struct variable *, int display_width);
 
+/* Alignment of data for display. */
+enum alignment 
+  {
+    ALIGN_LEFT = 0,
+    ALIGN_RIGHT = 1,
+    ALIGN_CENTRE = 2,
+    n_ALIGN
+  };
+
+bool alignment_is_valid (enum alignment);
 enum alignment var_get_alignment (const struct variable *);
 void var_set_alignment (struct variable *, enum alignment);
 
-/* Variable location in cases. */
-size_t var_get_value_cnt (const struct variable *);
-
 /* Whether variables' values should be preserved from case to
    case. */
 bool var_get_leave (const struct variable *);
+void var_set_leave (struct variable *, bool leave);
+bool var_must_leave (const struct variable *);
 
 /* Short names. */
 const char *var_get_short_name (const struct variable *);
 void var_set_short_name (struct variable *, const char *);
-void var_set_short_name_suffix (struct variable *, const char *, int suffix);
 void var_clear_short_name (struct variable *);
 
-/* Pointers to `struct variable', by name. */
-int compare_var_ptr_names (const void *, const void *, const void *);
-unsigned hash_var_ptr_name (const void *, const void *);
+/* Relationship with dictionary. */
+size_t var_get_dict_index (const struct variable *);
+size_t var_get_case_index (const struct variable *);
 
 /* Variable auxiliary data. */
+void *var_get_aux (const struct variable *);
 void *var_attach_aux (struct variable *,
                       void *aux, void (*aux_dtor) (struct variable *));
 void var_clear_aux (struct variable *);
 void *var_detach_aux (struct variable *);
 void var_dtor_free (struct variable *);
 
+/* Observed categorical values. */
+struct cat_vals *var_get_obs_vals (const struct variable *);
+void var_set_obs_vals (struct variable *, struct cat_vals *);
+bool var_has_obs_vals (const struct variable *);
+
 /* Classes of variables. */
 enum dict_class 
   {
@@ -201,27 +181,5 @@ enum dict_class 
 
 enum dict_class dict_class_from_id (const char *name);
 const char *dict_class_to_name (enum dict_class dict_class);
-
-/* Vector of variables. */
-struct vector
-  {
-    int idx;                    /* Index for dict_get_vector(). */
-    char name[LONG_NAME_LEN + 1]; /* Name. */
-    struct variable **var;	/* Vector of variables. */
-    int cnt;			/* Number of variables. */
-  };
-
-
-/* Return a string representing this variable, in the form most 
-   appropriate from a human factors perspective.
-   (IE: the label if it has one, otherwise the name )
-*/
-const char * var_to_string(const struct variable *var);
-
-
-int width_to_bytes(int width);
-
-union value * value_dup (const union value *val, int width);
-
 
 #endif /* !variable.h */
Index: src/data/vector.c
===================================================================
RCS file: src/data/vector.c
diff -N src/data/vector.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ src/data/vector.c	10 Dec 2006 03:30:21 -0000
@@ -0,0 +1,146 @@
+/* PSPP - computes sample statistics.
+   Copyright (C) 2006  Free Software Foundation, Inc.
+   Written by Ben Pfaff <blp@gnu.org>.
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+   02110-1301, USA. */
+
+#include <config.h>
+#include "vector.h"
+
+#include "dictionary.h"
+
+#include <libpspp/assertion.h>
+#include <libpspp/str.h>
+
+#include "xalloc.h"
+
+/* Vector of variables. */
+struct vector
+  {
+    char name[LONG_NAME_LEN + 1];       /* Name. */
+    struct variable **vars;             /* Set of variables. */
+    size_t var_cnt;                     /* Number of variables. */
+  };
+
+/* Checks that all the variables in VECTOR have consistent
+   width. */
+static void
+check_widths (const struct vector *vector) 
+{
+  int width = var_get_width (vector->vars[0]);
+  size_t i;
+  
+  for (i = 1; i < vector->var_cnt; i++)
+    assert (width == var_get_width (vector->vars[i]));
+}
+
+/* Creates and returns a new vector with the given NAME
+   that contains the VAR_CNT variables in VARS.
+   All variables in VARS must have the same type and width. */
+struct vector *
+vector_create (const char *name,
+               struct variable **vars, size_t var_cnt) 
+{
+  struct vector *vector = xmalloc (sizeof *vector);
+
+  assert (var_cnt > 0);
+  assert (var_is_plausible_name (name, false));
+  str_copy_trunc (vector->name, sizeof vector->name, name);
+
+  vector->vars = xmemdup (vars, var_cnt * sizeof *vector->vars);
+  vector->var_cnt = var_cnt;
+  check_widths (vector);
+
+  return vector;
+}
+
+/* Creates and returns a new vector as a clone of OLD, but that
+   contains variables from NEW_DICT that are in the same position
+   as those in OLD are in OLD_DICT. 
+   All variables in the new vector must have the same type and
+   width. */
+struct vector *
+vector_clone (const struct vector *old,
+              const struct dictionary *old_dict,
+              const struct dictionary *new_dict) 
+{
+  struct vector *new = xmalloc (sizeof *new);
+  size_t i;
+  
+  strcpy (new->name, old->name);
+
+  new->vars = xnmalloc (old->var_cnt, sizeof *new->vars);
+  new->var_cnt = old->var_cnt;
+  for (i = 0; i < new->var_cnt; i++) 
+    {
+      assert (dict_contains_var (old_dict, old->vars[i]));
+      new->vars[i] = dict_get_var (new_dict,
+                                   var_get_dict_index (old->vars[i]));
+    }
+  check_widths (new);
+  
+  return new;
+}
+
+/* Destroys VECTOR. */
+void
+vector_destroy (struct vector *vector) 
+{
+  free (vector->vars);
+  free (vector);
+}
+
+/* Returns VECTOR's name. */
+const char *
+vector_get_name (const struct vector *vector) 
+{
+  return vector->name;
+}
+
+/* Returns the type of the variables in VECTOR. */
+enum var_type vector_get_type (const struct vector *vector) 
+{
+  return var_get_type (vector->vars[0]);
+}
+
+/* Returns the variable in VECTOR with the given INDEX. */
+struct variable *
+vector_get_var (const struct vector *vector, size_t index) 
+{
+  assert (index < vector->var_cnt);
+  return vector->vars[index];
+}
+
+/* Returns the number of variables in VECTOR. */
+size_t
+vector_get_var_cnt (const struct vector *vector) 
+{
+  return vector->var_cnt;
+}
+
+/* Compares two pointers to vectors represented by A and B and
+   returns a strcmp()-type result. */
+int
+compare_vector_ptrs_by_name (const void *a_, const void *b_)
+{
+  struct vector *const *pa = a_;
+  struct vector *const *pb = b_;
+  struct vector *a = *pa;
+  struct vector *b = *pb;
+  
+  return strcasecmp (a->name, b->name);
+}
+
Index: src/data/vector.h
===================================================================
RCS file: src/data/vector.h
diff -N src/data/vector.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ src/data/vector.h	10 Dec 2006 03:30:21 -0000
@@ -0,0 +1,42 @@
+/* PSPP - computes sample statistics.
+   Copyright (C) 2006  Free Software Foundation, Inc.
+   Written by Ben Pfaff <blp@gnu.org>.
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+   02110-1301, USA. */
+
+#ifndef DATA_VECTOR_H 
+#define DATA_VECTOR_H 1
+
+#include <stddef.h>
+#include <data/variable.h>
+
+struct dictionary;
+
+struct vector *vector_create (const char *name,
+                              struct variable **var, size_t var_cnt);
+struct vector *vector_clone (const struct vector *old,
+                             const struct dictionary *old_dict,
+                             const struct dictionary *new_dict);
+void vector_destroy (struct vector *);
+
+const char *vector_get_name (const struct vector *);
+enum var_type vector_get_type (const struct vector *);
+struct variable *vector_get_var (const struct vector *, size_t idx);
+size_t vector_get_var_cnt (const struct vector *);
+
+int compare_vector_ptrs_by_name (const void *a_, const void *b_);
+
+#endif /* data/vector.h */
Index: src/language/control/do-if.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/control/do-if.c,v
retrieving revision 1.10
diff -u -p -r1.10 do-if.c
--- src/language/control/do-if.c	11 Nov 2006 23:10:00 -0000	1.10
+++ src/language/control/do-if.c	10 Dec 2006 03:30:21 -0000
@@ -24,7 +24,7 @@
 #include "control-stack.h"
 #include <data/procedure.h>
 #include <data/transformations.h>
-#include <data/variable.h>
+#include <data/value.h>
 #include <language/command.h>
 #include <language/expressions/public.h>
 #include <language/lexer/lexer.h>
Index: src/language/control/loop.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/control/loop.c,v
retrieving revision 1.11
diff -u -p -r1.11 loop.c
--- src/language/control/loop.c	11 Nov 2006 23:10:00 -0000	1.11
+++ src/language/control/loop.c	10 Dec 2006 03:30:22 -0000
@@ -294,7 +294,7 @@ loop_trns_proc (void *loop_, struct ccas
 
       /* Even if the loop is never entered, set the index
          variable to the initial value. */
-      case_data_rw (c, loop->index_var->fv)->f = loop->cur;
+      case_data_rw (c, loop->index_var)->f = loop->cur;
 
       /* Throw out pathological cases. */
       if (!finite (loop->cur) || !finite (loop->by) || !finite (loop->last)
@@ -355,7 +355,7 @@ end_loop_trns_proc (void *loop_, struct 
       if ((loop->by > 0.0 && loop->cur > loop->last)
           || (loop->by < 0.0 && loop->cur < loop->last))
         goto break_out;
-      case_data_rw (c, loop->index_var->fv)->f = loop->cur;
+      case_data_rw (c, loop->index_var)->f = loop->cur;
     }
 
   if (loop->loop_condition != NULL
Index: src/language/data-io/ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/ChangeLog,v
retrieving revision 1.34
diff -u -p -r1.34 ChangeLog
--- src/language/data-io/ChangeLog	1 Dec 2006 05:52:59 -0000	1.34
+++ src/language/data-io/ChangeLog	10 Dec 2006 03:30:22 -0000
@@ -1,3 +1,7 @@
+Sat Dec  9 18:43:34 2006  Ben Pfaff  <blp@gnu.org>
+
+	* list.q (cmd_list): Use new var_create, var_destroy functions.
+
 Thu Nov 30 21:51:58 2006  Ben Pfaff  <blp@gnu.org>
 
 	* inpt-pgm.c (cmd_reread): Always return error code upon detecting
Index: src/language/data-io/data-list.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/data-list.c,v
retrieving revision 1.27
diff -u -p -r1.27 data-list.c
--- src/language/data-io/data-list.c	5 Dec 2006 15:10:21 -0000	1.27
+++ src/language/data-io/data-list.c	10 Dec 2006 03:30:23 -0000
@@ -370,7 +370,7 @@ parse_fixed (struct lexer *lexer, struct
             /* Create specifier for parsing the variable. */
             spec = pool_alloc (dls->pool, sizeof *spec);
             spec->input = *f;
-            spec->fv = v->fv;
+            spec->fv = var_get_case_index (v);
             spec->record = record;
             spec->first_column = column;
             strcpy (spec->name, var_get_name (v));
@@ -498,7 +498,7 @@ parse_free (struct lexer *lexer, struct 
 
           spec = pool_alloc (dls->pool, sizeof *spec);
           spec->input = input;
-	  spec->fv = v->fv;
+	  spec->fv = var_get_case_index (v);
 	  strcpy (spec->name, var_get_name (v));
           ll_push_tail (&dls->specs, &spec->ll);
 	}
@@ -679,7 +679,7 @@ read_from_data_list_fixed (const struct 
       ll_for_each_continue (spec, struct dls_var_spec, ll, &dls->specs) 
         data_in (ss_substr (line, spec->first_column - 1, spec->input.w),
                  spec->input.type, spec->input.d, spec->first_column,
-                 case_data_rw (c, spec->fv), fmt_var_width (&spec->input));
+                 case_data_rw_idx (c, spec->fv), fmt_var_width (&spec->input));
 
       dfm_forward_record (dls->reader);
     }
@@ -715,7 +715,7 @@ read_from_data_list_free (const struct d
       
       data_in (field, spec->input.type, 0,
                dfm_get_column (dls->reader, ss_data (field)),
-               case_data_rw (c, spec->fv), fmt_var_width (&spec->input));
+               case_data_rw_idx (c, spec->fv), fmt_var_width (&spec->input));
     }
   return true;
 }
@@ -746,16 +746,16 @@ read_from_data_list_list (const struct d
             {
               int width = fmt_var_width (&spec->input);
               if (width == 0)
-                case_data_rw (c, spec->fv)->f = SYSMIS;
+                case_data_rw_idx (c, spec->fv)->f = SYSMIS;
               else
-                memset (case_data_rw (c, spec->fv)->s, ' ', width); 
+                memset (case_data_rw_idx (c, spec->fv)->s, ' ', width); 
             }
 	  break;
 	}
       
       data_in (field, spec->input.type, 0,
                dfm_get_column (dls->reader, ss_data (field)),
-               case_data_rw (c, spec->fv), fmt_var_width (&spec->input));
+               case_data_rw_idx (c, spec->fv), fmt_var_width (&spec->input));
     }
 
   dfm_forward_record (dls->reader);
@@ -794,7 +794,7 @@ data_list_trns_proc (void *dls_, struct 
   /* If there was an END subcommand handle it. */
   if (dls->end != NULL) 
     {
-      double *end = &case_data_rw (c, dls->end->fv)->f;
+      double *end = &case_data_rw (c, dls->end)->f;
       if (retval == TRNS_DROP_CASE)
         {
           *end = 1.0;
Index: src/language/data-io/get.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/get.c,v
retrieving revision 1.24
diff -u -p -r1.24 get.c
--- src/language/data-io/get.c	7 Dec 2006 05:41:11 -0000	1.24
+++ src/language/data-io/get.c	10 Dec 2006 03:30:24 -0000
@@ -28,6 +28,7 @@
 #include <data/case.h>
 #include <data/casefile.h>
 #include <data/fastfile.h>
+#include <data/format.h>
 #include <data/dictionary.h>
 #include <data/por-file-writer.h>
 #include <data/procedure.h>
@@ -1272,14 +1273,14 @@ mtf_delete_file_in_place (struct mtf_pro
   *file = f->next;
 
   if (f->in_var != NULL)
-    case_data_rw (&mtf->mtf_case, f->in_var->fv)->f = 0.;
+    case_data_rw (&mtf->mtf_case, f->in_var)->f = 0.;
   for (i = 0; i < dict_get_var_cnt (f->dict); i++)
     {
       struct variable *v = dict_get_var (f->dict, i);
       struct variable *mv = get_master (v);
       if (mv != NULL) 
         {
-          union value *out = case_data_rw (&mtf->mtf_case, mv->fv);
+          union value *out = case_data_rw (&mtf->mtf_case, mv);
 	  
           if (var_is_numeric (v))
             out->f = SYSMIS;
@@ -1427,23 +1428,23 @@ mtf_processing (const struct ccase *c, v
 	    {
 	      struct variable *v = dict_get_var (iter->dict, i);
               struct variable *mv = get_master (v);
+              size_t mv_index = mv ? var_get_dict_index (mv) : 0;
 	  
-	      if (mv != NULL && mtf->seq_nums[mv->index] != mtf->seq_num) 
+	      if (mv != NULL && mtf->seq_nums[mv_index] != mtf->seq_num) 
                 {
                   const struct ccase *record
                     = case_is_null (&iter->input) ? c : &iter->input;
-                  union value *out = case_data_rw (&mtf->mtf_case, mv->fv);
+                  union value *out = case_data_rw (&mtf->mtf_case, mv);
 
-                  mtf->seq_nums[mv->index] = mtf->seq_num;
+                  mtf->seq_nums[mv_index] = mtf->seq_num;
                   if (var_is_numeric (v))
-                    out->f = case_num (record, v->fv);
+                    out->f = case_num (record, v);
                   else
-                    memcpy (out->s, case_str (record, v->fv),
-                            var_get_width (v));
+                    memcpy (out->s, case_str (record, v), var_get_width (v));
                 } 
             }
           if (iter->in_var != NULL)
-            case_data_rw (&mtf->mtf_case, iter->in_var->fv)->f = 1.;
+            case_data_rw (&mtf->mtf_case, iter->in_var)->f = 1.;
 
           if (iter->type == MTF_FILE && iter->handle == NULL)
             read_active_file = true;
@@ -1461,11 +1462,12 @@ mtf_processing (const struct ccase *c, v
 	    {
 	      struct variable *v = dict_get_var (iter->dict, i);
               struct variable *mv = get_master (v);
+              size_t mv_index = mv ? var_get_dict_index (mv) : 0;
 
-	      if (mv != NULL && mtf->seq_nums[mv->index] != mtf->seq_num) 
+	      if (mv != NULL && mtf->seq_nums[mv_index] != mtf->seq_num) 
                 {
-                  union value *out = case_data_rw (&mtf->mtf_case, mv->fv);
-                  mtf->seq_nums[mv->index] = mtf->seq_num;
+                  union value *out = case_data_rw (&mtf->mtf_case, mv);
+                  mtf->seq_nums[mv_index] = mtf->seq_num;
 
                   if (var_is_numeric (v))
                     out->f = SYSMIS;
@@ -1474,7 +1476,7 @@ mtf_processing (const struct ccase *c, v
                 }
             }
           if (iter->in_var != NULL)
-            case_data_rw (&mtf->mtf_case, iter->in_var->fv)->f = 0.;
+            case_data_rw (&mtf->mtf_case, iter->in_var)->f = 0.;
 	}
 
       /* 5. Write the output record. */
@@ -1552,12 +1554,8 @@ mtf_merge_dictionary (struct dictionary 
         
           if (var_get_width (dv) == var_get_width (mv))
             {
-              if (val_labs_count (dv->val_labs)
-                  && !val_labs_count (mv->val_labs)) 
-                {
-                  val_labs_destroy (mv->val_labs);
-                  mv->val_labs = val_labs_copy (dv->val_labs); 
-                }
+              if (var_has_value_labels (dv) && !var_has_value_labels (mv))
+                var_set_value_labels (mv, var_get_value_labels (dv));
               if (var_has_missing_values (dv) && !var_has_missing_values (mv))
                 var_set_missing_values (mv, var_get_missing_values (dv));
             }
@@ -1584,7 +1582,7 @@ set_master (struct variable *v, struct v
 static struct variable *
 get_master (struct variable *v) 
 {
-  return v->aux;
+  return var_get_aux (v);
 }
 
 /* Case map.
@@ -1619,7 +1617,7 @@ start_case_map (struct dictionary *d) 
     {
       struct variable *v = dict_get_var (d, i);
       int *src_fv = xmalloc (sizeof *src_fv);
-      *src_fv = v->fv;
+      *src_fv = var_get_case_index (v);
       var_attach_aux (v, src_fv, var_dtor_free);
     }
 }
@@ -1654,13 +1652,13 @@ finish_case_map (struct dictionary *d) 
       int *src_fv = (int *) var_detach_aux (v);
       size_t idx;
 
-      if (v->fv != *src_fv)
+      if (var_get_case_index (v) != *src_fv)
         identity_map = 0;
       
       for (idx = 0; idx < value_cnt; idx++)
         {
           int src_idx = *src_fv + idx;
-          int dst_idx = v->fv + idx;
+          int dst_idx = var_get_case_index (v) + idx;
           
           assert (map->map[dst_idx] == -1);
           map->map[dst_idx] = src_idx;
@@ -1696,7 +1694,7 @@ map_case (const struct case_map *map,
     {
       int src_idx = map->map[dst_idx];
       if (src_idx != -1)
-        *case_data_rw (dst, dst_idx) = *case_data (src, src_idx);
+        *case_data_rw_idx (dst, dst_idx) = *case_data_idx (src, src_idx);
     }
 }
 
Index: src/language/data-io/inpt-pgm.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/inpt-pgm.c,v
retrieving revision 1.19
diff -u -p -r1.19 inpt-pgm.c
--- src/language/data-io/inpt-pgm.c	5 Dec 2006 15:10:21 -0000	1.19
+++ src/language/data-io/inpt-pgm.c	10 Dec 2006 03:30:24 -0000
@@ -169,7 +169,7 @@ cmd_input_program (struct lexer *lexer, 
       value_init |= var_get_leave (var) ? INP_INIT_ONCE : INP_REINIT;
 
       for (j = 0; j < value_cnt; j++)
-        inp->init[j + var->fv] = value_init;
+        inp->init[j + var_get_case_index (var)] = value_init;
     }
   for (i = 0; i < inp->init_cnt; i++)
     assert (inp->init[i] != -1);
@@ -198,14 +198,15 @@ init_case (const struct input_program_pg
     switch (inp->init[i]) 
       {
       case INP_NUMERIC | INP_INIT_ONCE:
-        case_data_rw (c, i)->f = 0.0;
+        case_data_rw_idx (c, i)->f = 0.0;
         break;
       case INP_NUMERIC | INP_REINIT:
-        case_data_rw (c, i)->f = SYSMIS;
+        case_data_rw_idx (c, i)->f = SYSMIS;
         break;
       case INP_STRING | INP_INIT_ONCE:
       case INP_STRING | INP_REINIT:
-        memset (case_data_rw (c, i)->s, ' ', sizeof case_data_rw (c, i)->s);
+        memset (case_data_rw_idx (c, i)->s, ' ',
+                sizeof case_data_rw_idx (c, i)->s);
         break;
       default:
         NOT_REACHED ();
@@ -224,12 +225,13 @@ clear_case (const struct input_program_p
       case INP_NUMERIC | INP_INIT_ONCE:
         break;
       case INP_NUMERIC | INP_REINIT:
-        case_data_rw (c, i)->f = SYSMIS;
+        case_data_rw_idx (c, i)->f = SYSMIS;
         break;
       case INP_STRING | INP_INIT_ONCE:
         break;
       case INP_STRING | INP_REINIT:
-        memset (case_data_rw (c, i)->s, ' ', sizeof case_data_rw (c, i)->s);
+        memset (case_data_rw_idx (c, i)->s, ' ',
+                sizeof case_data_rw_idx (c, i)->s);
         break;
       default:
         NOT_REACHED ();
Index: src/language/data-io/list.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/list.q,v
retrieving revision 1.22
diff -u -p -r1.22 list.q
--- src/language/data-io/list.q	5 Dec 2006 15:10:21 -0000	1.22
+++ src/language/data-io/list.q	10 Dec 2006 03:30:24 -0000
@@ -134,7 +134,7 @@ write_line (struct outp_driver *d, const
 int
 cmd_list (struct lexer *lexer, struct dataset *ds)
 {
-  struct variable casenum_var;
+  struct variable *casenum_var = NULL;
   bool ok;
 
   if (!parse_list (lexer, ds, &cmd, NULL))
@@ -215,10 +215,8 @@ cmd_list (struct lexer *lexer, struct da
       /* Initialize the case-number variable. */
       int width = cmd.last == LONG_MAX ? 5 : intlog10 (cmd.last);
       struct fmt_spec format = fmt_for_output (FMT_F, width, 0);
-      var_set_name (&casenum_var, "Case#");
-      casenum_var.width = 0;
-      casenum_var.fv = -1;
-      var_set_both_formats (&casenum_var, &format);
+      casenum_var = var_create ("Case#", 0);
+      var_set_both_formats (casenum_var, &format);
 
       /* Add the weight variable at the beginning of the variable list. */
       cmd.n_variables++;
@@ -226,7 +224,7 @@ cmd_list (struct lexer *lexer, struct da
                                    cmd.n_variables, sizeof *cmd.v_variables);
       memmove (&cmd.v_variables[1], &cmd.v_variables[0],
 	       (cmd.n_variables - 1) * sizeof *cmd.v_variables);
-      cmd.v_variables[0] = &casenum_var;
+      cmd.v_variables[0] = casenum_var;
     }
 
   determine_layout ();
@@ -237,6 +235,8 @@ cmd_list (struct lexer *lexer, struct da
 
   clean_up ();
 
+  var_destroy (casenum_var);    
+
   return ok ? CMD_SUCCESS : CMD_CASCADING_FAILURE;
 }
 
@@ -625,7 +625,7 @@ determine_layout (void)
 
 /* Writes case C to output. */
 static bool
-list_cases (const struct ccase *c, void *aux UNUSED, const struct dataset *ds UNUSED)
+list_cases (const struct ccase *c, void *aux UNUSED, const struct dataset *ds)
 {
   struct outp_driver *d;
   
@@ -681,9 +681,10 @@ list_cases (const struct ccase *c, void 
 	    if (width > print->w)
               ds_put_char_multiple(&line_buffer, ' ', width - print->w);
 
-            if (fmt_is_string (print->type) || v->fv != -1)
+            if (fmt_is_string (print->type)
+                || dict_contains_var (dataset_dict (ds), v))
 	      {
-                data_out (case_data (c, v->fv), print,
+                data_out (case_data (c, v), print,
                           ds_put_uninit (&line_buffer, print->w));
 	      }
             else 
@@ -719,8 +720,9 @@ list_cases (const struct ccase *c, void 
             const struct fmt_spec *print = var_get_print_format (v);
 	    char buf[256];
 	    
-            if (fmt_is_string (print->type) || v->fv != -1)
-	      data_out (case_data (c, v->fv), print, buf);
+            if (fmt_is_string (print->type)
+                || dict_contains_var (dataset_dict (ds), v))
+	      data_out (case_data (c, v), print, buf);
             else 
               {
                 union value case_idx_value;
